Subject: bug#65621: [PATCH] `dired-next-line' go to meaningful line

From: Drew Adams <[email-masked]>
Date: Sun, 3 Sep 2023 21:47:28 +0000

> > > Drew wants to skip the current directory
> > > and the parent directory;
> >
> > No, he doesn't.  Not at all.  Definitely not.
> > I think maybe you misread what I wrote.
> 
> You really confused me.  If you don't want it,
> why mentioned it twice?

I mentioned it only because you were defining a
Boolean option `dired-headerline-is-meaningful'.

I wanted to let you know that `.' and `..' are
also lines that you might want to let the
option skip over, because vanilla Emacs doesn't
allow actions on them sometimes.

IOW, IF you're going to have an option for
choosing which lines are "meaningful", THEN you
might want to allow for header lines too, as
another kind of line to skip.

I clearly introduced that FYI with "FWIW", and
added:

  Dunno whether you want to include optionally
  skipping over them with `n'|`p', i.e., via
  `dired-cursor-goto-meaningful-line.

Clearly I wasn't _requesting_ being able to
skip `.' and `..' lines, and a conclusion that
Drew _asked_ for that was unwarranted.  As was
the further conclusion that his supposed ask
for that conflicted with his (repeated) FYIs
that this was _not_ something he requested.

The contradiction and confusion were in your
imagination, I'm afraid.  I think I was clear
from the outset.

If it were I, I'd have done what I did in
Dired+: no option to decide what lines are
"meaningful".

I do think it's fine to skip over blank lines
(which Dired+ hasn't done).  But I saw and I
see no real need for an option such as
`dired-headerline-is-meaningful'.  (I think
Stefan said that too, and I see you've now
removed it.)

What I argued for was having `n' and `p' go
to header lines, as they always have.  To
accommodate _your_ wish to _not_ do that I
suggested you make that optional (but have
skipping such lines be opt-in).

IOW, I suggested an option to accommodate
your new behavior (skip header lines) as
well as to respect Emacs's longstanding
(and more useful) behavior of not skipping
them.

> You proposed this idea:
> 
> > What I said was that for _vanilla_
> > Emacs some actions aren't allowed
> > on `.' and `..'.  And so based on
> > that, you or someone else (NOT I),
> > might want those lines, in addition
> > to blank lines, to be skipped over
> > as "meaningless".
> 
> and then rejected it:
> 
> > I'd say that none of the complications
> > you've offered with this latest
> > suggestion are helpful.

You elided the real point I made there:

  I'd suggest that skipping over blank lines, if
  you want to do that, is enough.  And offering
  cycling is a nice-to-have, but is orthogonal to
  the bug report.

And that matches what you ended up with.

> Inconsistent.
> 
> If you don't want it and you don't want anyone else to use it, then
> do not mention it in the first place.

I mentioned it because you were looking to
have users customize the kinds of lines
they want to consider "meaningless" (and
thus skip over).

I was just trying to help you in your attempt
to do that, by offering an FYI about another
kind of line that vanilla Emacs sometimes
allows no action on.

HTH.